#include <iostream>
#include <string>

using namespace std;

struct TBase
{
  virtual void print (void);
};

struct TInteger: public TBase
{
  int content;
  virtual void print (void);
  TInteger (int i);
};

struct TString: public TBase
{
  string content;
  virtual void print (void);
  TString (string s);
};

void TBase::print (void)
{
  cout << "Base" << endl;
}

void TInteger::print (void)
{
  cout << "Integer: " << content << endl;
}

TInteger::TInteger (int i)
{
  content = i;
}

void TString::print (void)
{
  cout << "String: " << content << endl;
}

TString::TString (string s)
{
  content = s;
}

int main (void)
{
  TInteger i = 42;
  TBase *object[] = { &i, new TString ("Hello, world!") };

  for (int i = 0; i < 2; i++)
    object[i]->print ();

  return 0;
}
