#include <iostream>

using namespace std;

template <typename contentType> class node
{
  public:
    contentType content;
    node *next;
    void insertAfter (node *newNode)
    {
      if (newNode)
        newNode->next = next;
      next = newNode;
    }
};

int main ()
{
  node <int> A, B, C, D;
  A.content = 2;
  A.next = &B;
  B.content = 3;
  B.next = &C;
  C.content = 5;
  C.next = &D;
  D.content = 7;
  D.next = NULL;
  for (node <int> *p = &A; p; p = p->next)
    cout << p->content << endl;
  node <int> BO;
  BO.content = 4;
  B.insertAfter (&BO);
  for (node <int> *p = &A; p; p = p->next)
    cout << p->content << endl;
  node <string> E, F;
  E.content = "Hello, ";
  E.next = NULL;
  F.content = "world!";
  F.next = NULL;
  E.insertAfter (&F);
  for (node <string> *p = &E; p; p = p->next)
    cout << p->content << endl;
  return 0;
}
